aboutsummaryrefslogtreecommitdiffstats
path: root/examples/scripts/hanoi.bash
diff options
context:
space:
mode:
authorcvpcs <root@cvpcs.org>2010-06-02 11:02:31 -0500
committercvpcs <root@cvpcs.org>2010-06-02 11:02:31 -0500
commit772f20abb0a3a0979c440114bf3a1cff5b3cef03 (patch)
tree3384b9291d73a12542c526a8557218c7435491b0 /examples/scripts/hanoi.bash
downloadexternal_bash-772f20abb0a3a0979c440114bf3a1cff5b3cef03.zip
external_bash-772f20abb0a3a0979c440114bf3a1cff5b3cef03.tar.gz
external_bash-772f20abb0a3a0979c440114bf3a1cff5b3cef03.tar.bz2
initial import of bash 4.1
Diffstat (limited to 'examples/scripts/hanoi.bash')
-rw-r--r--examples/scripts/hanoi.bash21
1 files changed, 21 insertions, 0 deletions
diff --git a/examples/scripts/hanoi.bash b/examples/scripts/hanoi.bash
new file mode 100644
index 0000000..c308125
--- /dev/null
+++ b/examples/scripts/hanoi.bash
@@ -0,0 +1,21 @@
+# Towers of Hanoi in bash
+#
+# cribbed from the ksh93 book, example from exercises on page 85
+#
+# Chet Ramey
+# chet@po.cwru.edu
+
+hanoi() # n from to spare
+{
+ typeset -i nm1=$1-1
+ ((nm1>0)) && hanoi $nm1 $2 $4 $3
+ echo "Move disc $2 to $3"
+ ((nm1>0)) && hanoi $nm1 $4 $3 $2
+}
+
+case $1 in
+[1-9])
+ hanoi $1 1 2 3;;
+*) echo "${0##*/}: Argument must be from 1 to 9"
+ exit 1;;
+esac